uint8_t fb6(uint64_t);
uint8_t fb7(uint64_t);
uint8_t fb9(uint64_t);
uint8_t fb10(uint64_t);
uint8_t fb11(uint64_t);
uint8_t fb12(uint64_t);

/*****************************************************************/
/** Feedback bit for Achterbahn register A6 (length  27)        **/
/*****************************************************************/
uint8_t fb6(uint64_t reg)
 {
  uint8_t fb; 

  fb  = ((reg >>  0) ^ (reg >> 3) ^ (reg >> 4) ^ (reg >> 15) ^ (reg >> 25)) & 1;
  fb ^= ((((reg >>  1) & (reg >>  3)) ^ ((reg >>  1) & (reg >>  8)) ^ ((reg >>  1) & (reg >> 12))) & 1);
  fb ^= ((((reg >>  6) & (reg >> 17)) ^ ((reg >> 10) & (reg >> 13)) ^ ((reg >> 10) & (reg >> 17)) ^ ((reg >> 13) & (reg >> 14))) & 1);
  fb ^= (((reg >>  5) & (reg >> 10) & (reg >> 11) & (reg >> 18)) & 1);
  fb ^= (((reg >>  2) & (reg >>  5) & (reg >> 11) & (reg >> 16) & (reg >> 18)) & 1);
  fb ^= (((reg >>  2) & (reg >>  5) & (reg >> 11) & (reg >> 17) & (reg >> 18)) & 1);
  fb ^= (((reg >>  5) & (reg >> 10) & (reg >> 11) & (reg >> 13) & (reg >> 18)) & 1);
  fb ^= (((reg >>  5) & (reg >> 11) & (reg >> 13) & (reg >> 14) & (reg >> 18)) & 1);
  fb ^= (((reg >>  5) & (reg >> 11) & (reg >> 16) & (reg >> 17) & (reg >> 18)) & 1);

  return(fb);
 }

/*****************************************************************/
/** Feedback bit for Achterbahn register A7 (length  28)        **/
/*****************************************************************/
uint8_t fb7(uint64_t reg)
 {
  uint8_t fb;

  fb  = ((reg >>  0) ^ (reg >> 1) ^ (reg >> 5) ^ (reg >> 20) ^ (reg >> 25)) & 1;
  fb ^= ((((reg >>  1) & (reg >>  2)) ^ ((reg >>  2) & (reg >> 17)) ^ ((reg >>  4) & (reg >> 12))) & 1);
  fb ^= ((((reg >> 10) & (reg >> 15)) ^ ((reg >> 10) & (reg >> 18)) ^ ((reg >> 14) & (reg >> 16)) ^ ((reg >> 16) & (reg >> 20))) & 1);
  fb ^= (((reg >>  7) & (reg >>  9) & (reg >> 18) & (reg >> 19)) & 1);
  fb ^= (((reg >>  7) & (reg >>  9) & (reg >> 10) & (reg >> 15) & (reg >> 19)) & 1);
  fb ^= (((reg >>  7) & (reg >>  9) & (reg >> 10) & (reg >> 18) & (reg >> 19)) & 1);
  fb ^= (((reg >>  1) & (reg >>  2) & (reg >>  7) & (reg >>  9) & (reg >> 13) & (reg >> 19)) & 1);

  return(fb);
 }

/*****************************************************************/
/** Feedback bit for Achterbahn register A9 (length  30)        **/
/*****************************************************************/
uint8_t fb9(uint64_t reg)
 {
  uint8_t fb;

  fb  = ((reg >>  0) ^ (reg >> 1) ^ (reg >> 7) ^ (reg >> 10) ^ (reg >> 12) ^ (reg >> 18) ^ (reg >> 28)) & 1;
  fb ^= ((((reg >>  2) & (reg >>  8)) ^ ((reg >>  4) & (reg >>  7)) ^ ((reg >>  4) & (reg >> 18))) & 1);
  fb ^= ((((reg >> 10) & (reg >> 12)) ^ ((reg >> 10) & (reg >> 19)) ^ ((reg >> 10) & (reg >> 22)) ^ ((reg >> 14) & (reg >> 22))) & 1);
  fb ^= (((reg >>  3) & (reg >>  5) & (reg >>  7)) & 1);
  fb ^= (((reg >>  3) & (reg >>  7) & (reg >>  8)) & 1);
  fb ^= (((reg >>  5) & (reg >>  7) & (reg >>  8)) & 1);
  fb ^= (((reg >>  1) & (reg >>  3) & (reg >>  5) & (reg >>  9)) & 1);
  fb ^= (((reg >>  1) & (reg >>  3) & (reg >>  5) & (reg >> 21)) & 1);
  fb ^= (((reg >>  1) & (reg >>  3) & (reg >>  8) & (reg >>  9)) & 1);
  fb ^= (((reg >>  1) & (reg >>  3) & (reg >>  8) & (reg >> 21)) & 1);
  fb ^= (((reg >>  1) & (reg >>  5) & (reg >>  8) & (reg >>  9)) & 1);
  fb ^= (((reg >>  1) & (reg >>  5) & (reg >>  8) & (reg >> 21)) & 1);
  fb ^= (((reg >>  3) & (reg >>  4) & (reg >>  5) & (reg >>  7)) & 1);
  fb ^= (((reg >>  3) & (reg >>  4) & (reg >>  5) & (reg >> 18)) & 1);
  fb ^= (((reg >>  3) & (reg >>  4) & (reg >>  7) & (reg >>  8)) & 1);
  fb ^= (((reg >>  3) & (reg >>  4) & (reg >>  8) & (reg >> 18)) & 1);
  fb ^= (((reg >>  3) & (reg >>  5) & (reg >>  9) & (reg >> 21)) & 1);
  fb ^= (((reg >>  3) & (reg >>  8) & (reg >>  9) & (reg >> 21)) & 1);
  fb ^= (((reg >>  4) & (reg >>  5) & (reg >>  7) & (reg >>  8)) & 1);
  fb ^= (((reg >>  4) & (reg >>  5) & (reg >>  8) & (reg >> 18)) & 1);
  fb ^= (((reg >>  5) & (reg >>  8) & (reg >>  9) & (reg >> 21)) & 1);

  return(fb);
 }

/*****************************************************************/
/** Feedback bit for Achterbahn register A10 (length  31)       **/
/*****************************************************************/
uint8_t fb10(uint64_t reg)
 {
  uint8_t fb;

  fb  = ((reg >>  0) ^ (reg >> 2) ^ (reg >> 5) ^ (reg >>  6) ^ (reg >> 15) ^ (reg >> 17) ^ (reg >> 18)^ (reg >> 20) ^ (reg >> 25)) & 1;
  fb ^= ((((reg >>  8) & (reg >> 18)) ^ ((reg >>  8) & (reg >> 20)) ^ ((reg >> 12) & (reg >> 21))) & 1);
  fb ^= ((((reg >> 14) & (reg >> 19)) ^ ((reg >> 17) & (reg >> 21)) ^ ((reg >> 20) & (reg >> 22))) & 1);
  fb ^= (((reg >>  4) & (reg >> 12) & (reg >> 22)) & 1);
  fb ^= (((reg >>  4) & (reg >> 19) & (reg >> 22)) & 1);
  fb ^= (((reg >>  7) & (reg >> 20) & (reg >> 21)) & 1);
  fb ^= (((reg >>  8) & (reg >> 18) & (reg >> 22)) & 1);
  fb ^= (((reg >>  8) & (reg >> 20) & (reg >> 22)) & 1);
  fb ^= (((reg >> 12) & (reg >> 19) & (reg >> 22)) & 1);
  fb ^= (((reg >> 20) & (reg >> 21) & (reg >> 22)) & 1);
  fb ^= (((reg >>  4) & (reg >>  7) & (reg >> 12) & (reg >> 21)) & 1);
  fb ^= (((reg >>  4) & (reg >>  7) & (reg >> 19) & (reg >> 21)) & 1);
  fb ^= (((reg >>  4) & (reg >> 12) & (reg >> 21) & (reg >> 22)) & 1);
  fb ^= (((reg >>  4) & (reg >> 19) & (reg >> 21) & (reg >> 22)) & 1);
  fb ^= (((reg >>  7) & (reg >>  8) & (reg >> 18) & (reg >> 21)) & 1);
  fb ^= (((reg >>  7) & (reg >>  8) & (reg >> 20) & (reg >> 21)) & 1);
  fb ^= (((reg >>  7) & (reg >> 12) & (reg >> 19) & (reg >> 21)) & 1);
  fb ^= (((reg >>  8) & (reg >> 18) & (reg >> 21) & (reg >> 22)) & 1);
  fb ^= (((reg >>  8) & (reg >> 20) & (reg >> 21) & (reg >> 22)) & 1);
  fb ^= (((reg >> 12) & (reg >> 19) & (reg >> 21) & (reg >> 22)) & 1);

  return(fb);
 }

/*****************************************************************/
/** Feedback bit for Achterbahn register A11 (length  32)       **/
/*****************************************************************/
uint8_t fb11(uint64_t reg)
 {
  uint8_t fb;

  fb  = ((reg >>  0) ^ (reg >> 3) ^ (reg >> 17) ^ (reg >> 22) ^ (reg >> 28)) & 1;
  fb ^= ((((reg >>  2) & (reg >> 13)) ^ ((reg >>  5) & (reg >> 19)) ^ ((reg >>  7) & (reg >> 19))) & 1);
  fb ^= ((((reg >>  8) & (reg >> 12)) ^ ((reg >>  8) & (reg >> 13)) ^ ((reg >> 13) & (reg >> 15))) & 1);
  fb ^= (((reg >>  2) & (reg >> 12) & (reg >> 13)) & 1);
  fb ^= (((reg >>  7) & (reg >>  8) & (reg >> 12)) & 1);
  fb ^= (((reg >>  7) & (reg >>  8) & (reg >> 14)) & 1);
  fb ^= (((reg >>  8) & (reg >> 12) & (reg >> 13)) & 1);
  fb ^= (((reg >>  2) & (reg >>  7) & (reg >> 12) & (reg >> 13)) & 1);
  fb ^= (((reg >>  2) & (reg >>  7) & (reg >> 13) & (reg >> 14)) & 1);
  fb ^= (((reg >>  4) & (reg >> 11) & (reg >> 12) & (reg >> 24)) & 1);
  fb ^= (((reg >>  7) & (reg >>  8) & (reg >> 12) & (reg >> 13)) & 1);
  fb ^= (((reg >>  7) & (reg >>  8) & (reg >> 13) & (reg >> 14)) & 1);
  fb ^= (((reg >>  4) & (reg >>  7) & (reg >> 11) & (reg >> 12) & (reg >> 24)) & 1);
  fb ^= (((reg >>  4) & (reg >>  7) & (reg >> 11) & (reg >> 14) & (reg >> 24)) & 1);

  return(fb);
 }

/*****************************************************************/
/** Feedback bit for Achterbahn register A12 (length  33)       **/
/*****************************************************************/
uint8_t fb12(uint64_t reg)
 {
  uint8_t fb;

  fb  = ((reg >>  0) ^ (reg >> 2) ^ (reg >>  7) ^ (reg >>  9) ^ (reg >> 10) ^ (reg >> 15) ^ (reg >> 23) ^ (reg >> 25) ^ (reg >> 30)) & 1;
  fb ^= ((((reg >>  8) & (reg >> 15)) ^ ((reg >> 12) & (reg >> 16)) ^ ((reg >> 13) & (reg >> 15)) ^ ((reg >> 13) & (reg >> 25))) & 1);
  fb ^= (((reg >>  1) & (reg >>  8) & (reg >> 14)) & 1);
  fb ^= (((reg >>  1) & (reg >>  8) & (reg >> 18)) & 1);
  fb ^= (((reg >>  8) & (reg >> 12) & (reg >> 16)) & 1);
  fb ^= (((reg >>  8) & (reg >> 14) & (reg >> 18)) & 1);
  fb ^= (((reg >>  8) & (reg >> 15) & (reg >> 16)) & 1);
  fb ^= (((reg >>  8) & (reg >> 15) & (reg >> 17)) & 1);
  fb ^= (((reg >> 15) & (reg >> 17) & (reg >> 24)) & 1);
  fb ^= (((reg >>  1) & (reg >>  8) & (reg >> 14) & (reg >> 17)) & 1);
  fb ^= (((reg >>  1) & (reg >>  8) & (reg >> 17) & (reg >> 18)) & 1);
  fb ^= (((reg >>  1) & (reg >> 14) & (reg >> 17) & (reg >> 24)) & 1);
  fb ^= (((reg >>  1) & (reg >> 17) & (reg >> 18) & (reg >> 24)) & 1);
  fb ^= (((reg >>  8) & (reg >> 12) & (reg >> 16) & (reg >> 17)) & 1);
  fb ^= (((reg >>  8) & (reg >> 14) & (reg >> 17) & (reg >> 18)) & 1);
  fb ^= (((reg >>  8) & (reg >> 15) & (reg >> 16) & (reg >> 17)) & 1);
  fb ^= (((reg >> 12) & (reg >> 16) & (reg >> 17) & (reg >> 24)) & 1);
  fb ^= (((reg >> 14) & (reg >> 17) & (reg >> 18) & (reg >> 24)) & 1);
  fb ^= (((reg >> 15) & (reg >> 16) & (reg >> 17) & (reg >> 24)) & 1);

  return(fb);
 }

